prettyErrorStack = require './prettyErrorStack'
{ typeOf } = require './utils'

module.exports = events = (emitter, lance) ->
	# todo:
	#	capture:
	#		at GeneratorFunctionPrototype.next (native)
	#	remove any /node_modules/bluebird/js/main/promise.js
	#	types of errors. generic ones that are just noise
	emitter.on 'error', (err, scope = '', reverse) ->
		stack	= prettyErrorStack err, scope, reverse
		console.error stack

	#
	# Decorations
	#

	emitter.on 'request', (o) ->
		# todo: echo time diff on serve according to cfg flag
		timeDiff = new Date().getTime() - o.time.getTime()
		timeUnit = 'ms'

		if timeDiff > 1000
			timeDiff = timeDiff / 1000
			timeUnit = 's'

		console.log(
			( ' ' + timeDiff + timeUnit ).grey
			o.method.grey.bold
			( o.route.url.href ).toString().green
			require('util').inspect( o.path ).toString()[0..100].grey
			require('util').inspect( o.query ).toString()[0..100].grey
		)

	emitter.on 'templater.ready', ->
		console.log '~ templater'.grey, 'ready'.green

	emitter.on 'server.starting', ->
		cfg = lance.cfg.server
		console.log '~ server'.grey, 'starting', 'on'.grey, ( if cfg.method is 'socket' then cfg.socket else cfg.host + ':' + cfg.port ).cyan

	emitter.on 'server.listening', ->
		console.log '~ server'.grey, 'listening'.green

	emitter.on 'server.ready', ->	console.log '~ server'.grey, 'ready'.green
	emitter.on 'ready', ->			console.log '~'.grey, 'ready'.green

	cfg = lance.cfg.templater

	if cfg.debug
		emitter.on 'templater.find', (findIn, findExt) ->
			console.log '= templater.find'.grey, findExt.toString(), 'in'.grey, findIn.toString()

		if typeOf.Object cfg.debug
			if cfg.debug.watch
				emitter.on 'templater.watch', (fileDir) ->
					console.log '= templater.watch'.grey, fileDir

				emitter.on 'templater.watch.change', (fileDir, event) ->
					console.log '= templater.watch.change'.grey, fileDir

			if cfg.debug.render
				emitter.on 'templater.render.template', (fileDir) ->
					console.log '= templater.render.template'.grey, fileDir

				emitter.on 'templater.render.css', (fileDir) ->
					console.log '= templater.render.css'.grey, fileDir

				emitter.on 'templater.render.js', (fileDir) ->
					console.log '= templater.render.js'.grey, fileDir

				emitter.on 'templater.render.coffee', (fileDir) ->
					console.log '= templater.render.coffee'.grey, fileDir

				emitter.on 'templater.render.stylus', (fileDir) ->
					console.log '= templater.render.stylus'.grey, fileDir

			if cfg.debug.files
				#emitter.on 'templater.find.file', (file, fileDir) ->
				#	console.log '= templater.find.file'.grey, fileDir
					
				emitter.on 'templater.find.fileMatch', (file, fileDir) ->
					console.log '= templater.find.fileMatch'.grey, fileDir
					
				emitter.on 'templater.writeFile', (to) ->
					console.log '= templater.writeFile'.grey, 'to'.grey, to

			if cfg.debug.merge
				emitter.on 'templater.render.merge', (model) ->
					console.log '= templater.render.merge'.grey, model.ext

				emitter.on 'templater.render.merge.add', (fileDir, model) ->
					console.log '= templater.render.merge.add'.grey, model.ext, 'in'.grey, fileDir

				emitter.on 'templater.render.merge.add search', (fileDir, group) ->
					console.log '= templater.render.merge.add'.grey, 'searching'.cyan, '\t', group.saveTo, 'for'.grey, fileDir

				emitter.on 'templater.render.merge merged', (mergeFiles, group) ->
					console.log '= templater.render.merge merged'.grey, group.saveTo.cyan, mergeFiles

				emitter.on 'templater.render.merge.add matching', (fileDir, constructedDir) ->
					console.log '= templater.render.merge.add'.grey, 'matching', '\t', constructedDir

				emitter.on 'templater.render.merge.add matched', (fileDir, group) ->
					console.log '= templater.render.merge.add'.grey, 'matched'.green, '\t', fileDir

				emitter.on 'templater.render.merge.add unmatched', (fileDir, group) ->
					console.log '= templater.render.merge.add'.grey, 'unmatched'.red, '\t', fileDir

events.relay = (emitter1, emitter2) ->
	oldEmit = emitter1.emit
	emitter1.emit = ->
		oldEmit.apply emitter1, arguments
		emitter2.emit.apply emitter2, arguments

